var UserAuthorizationSign = localStorage.getItem('UserAuthorizationSign');
if (!UserAuthorizationSign) {

	mui.openWindow({
		url: "../login.html",
		id: "login"
	})
}

var wrap = new Vue({
	el: '#wrap',
	data: {
		quList: [],
		deskList: [],
		selectDeskid: '',
		ywList: '',
		cusinfo: '', //客户名称
		custel: '', //客户电话
		emp_id: '', //业务员id
		num: '', //人数
		reg: /^1[345789]\d{9}$/,
		zhuolist: [],
		error: '',
		yewuyuan: '',
		yewu: '',
		bak:''
	},
	created: function() {
		pageload();
		this.getQu();
		this.getDesk();
	},
	mounted: function() {
		this.getzhuolist();
	},
	methods: {
		getQu: function() {
			console.log('11111');
			var that = this;
			mui.ajax('http://dci.10le.cn/default/index', {
				data: "",
				dataType: 'json',
				type: 'GET',
				timeout: 10000, //超时时间设置为10秒；
				headers: {
					'Content-Type': 'application/json',
					'UserAuthorizationSign': localStorage["UserAuthorizationSign"]
				},
				success: function(data) {
					that.quList = data.Body.cq;
				},
				complete: function(XMLHttpRequest, status) {
					if (status == 'timeout') {
						that.getQu();
					}
				}
			});
		},
		getDesk: function() {
			var that = this;
			//获取桌子
			mui.ajax('http://dci.10le.cn/default/desk', {
				data: "",
				dataType: 'json',
				type: 'GET',
				timeout: 10000, //超时时间设置为10秒；
				headers: {
					'Content-Type': 'application/json',
					'UserAuthorizationSign': localStorage["UserAuthorizationSign"]
				},
				success: function(data) {

					that.deskList = data.Body.desklist;
				},
				complete: function(XMLHttpRequest, status) {
					if (status == 'timeout') {
						that.getDesk();
					}
				}
			});
		},
		getzhuolist: function() {
			if (users != 0) {
				var _this = this;
				mui.ajax({
					url: globalurl + 'getzhuohao',
					data: {
						user: users
					},
					type: 'POST',
					dataType: 'json',
					success: function(data) {

						if (data.Success) {
							_this.zhuolist = data.Data[0];
							_this.error = data.Success;
						} else {
							_this.error = data.Success;
							_this.zhuolist = [];
						}
					},
					error: function(xhr, type, errorThrown) {
						mui.toast(type);
					}
				});
			}
		},
		//业务员
		yw: function() {
			var that = this;
			mui.ajax('http://dci.10le.cn/default/emp', {
				data: "",
				dataType: 'json',
				type: 'GET',
				timeout: 10000, //超时时间设置为10秒；
				headers: {
					'Content-Type': 'application/json',
					'UserAuthorizationSign': localStorage["UserAuthorizationSign"]
				},
				success: function(data) {
					that.ywList = data.Body;
				},
				complete: function(XMLHttpRequest, status) {
					if (status == 'timeout') {
						that.yw();
					}
				}
			});
		}
	}
})

mui('#wrap').on('tap', '#comeTime', function() {
	var date = new Date();
	var y = date.getFullYear(),
		month = date.getMonth(),
		d = date.getDate(),
		h = date.getHours(),
		m = date.getMinutes();
	var dtpicker = new mui.DtPicker({
		"type": "datetime",
		beginDate: new Date(y, month, d, h, m),
		endDate: new Date(2500, 0, 1)
	})
	dtpicker.show(function(rs) {
		document.getElementById("comeTime").value = rs.text;
		var date = new Date(rs.text);
		var time1 = date.getTime();
		var time2 = time1 + 1000 * 60 * 30;
		document.getElementById("expire").value = formatDateTime(time2);
		//销毁时间控件
		dtpicker.dispose();
	})
})

function formatDateTime(inputTime) {
	var date = new Date(inputTime);
	var y = date.getFullYear();
	var m = date.getMonth() + 1;
	m = m < 10 ? ('0' + m) : m;
	var d = date.getDate();
	d = d < 10 ? ('0' + d) : d;
	var h = date.getHours();
	h = h < 10 ? ('0' + h) : h;
	var minute = date.getMinutes();
	var second = date.getSeconds();
	minute = minute < 10 ? ('0' + minute) : minute;
	return y + '-' + m + '-' + d + ' ' + h + ':' + minute;
};
//弹出
mui('#wrap').on('tap', '#yudingDesk', function() {

	mui('.middlePopover').popover('show');
	mui('.mui-scroll-wrapper').scroll();
	document.documentElement.style.overflow = "hidden";
})
mui('#wrap').on('tap', '#yudingyewu', function() {

	mui('.zhuohaolists').popover('show');
	mui('.mui-scroll-wrapper').scroll();
	document.documentElement.style.overflow = "hidden";
})
mui('#wrap').on('tap', '.canceldesk', function() {

	mui('.zhuohaolists').popover('hide');
	mui('.middlePopover').popover('hide');
})
//2个选择
mui('#wrap').on('tap', '.okDesk', function() {
	var desk = mui('#deskList')[0].querySelectorAll('input[type="checkbox"]:checked');

	wrap.selectDeskid = '';
	var html_ = '';
	mui.each(desk, function(index, item) {
		html_ += item.getAttribute('deskName') + '、';
		//wrap.selectDeskid += item.getAttribute('deskid') + ',';
	})

	//mui('#yudingDesk')[0].value = html_.slice(0, html_.length - 1);
	//wrap.selectDeskid = wrap.selectDeskid.slice(0, wrap.selectDeskid.length - 1);
	wrap.selectDeskid = html_.slice(0, html_.length - 1);
	mui('.middlePopover').popover('hide');
	document.documentElement.style.overflow = "scroll";
})
mui('#wrap').on('tap', '.okyewu', function() {

	var desk = mui('#yewulist')[0].querySelectorAll('input[type="checkbox"]:checked');
	var html_ = '';
	wrap.yewu = '';
	mui.each(desk, function(index, item) {
		html_ += item.getAttribute('deskName') + '('+item.getAttribute('qianzhui')+ ')、';
	})
	wrap.yewu = html_.slice(0, html_.length - 1);
	mui('.zhuohaolists').popover('hide');
	document.documentElement.style.overflow = "scroll";
})


mui('body').on('tap', '.mui-backdrop', function() {
	mui('.middlePopover').popover('hide');
	document.documentElement.style.overflow = "scroll";
})
mui('#wrap').on('tap', '#okBtn', function() {
	
	var check = true;
	if (!wrap.num) {
		mui.alert('请输入人数', ' ', function() {}, 'div');
		return;
		//check = false;
	}
	if (!mui("#comeTime")[0].value) {
		mui.alert('请输入到店时间', ' ', function() {}, 'div');
		return;
		//check = false;
	}
	if (check) {
		mui.ajax({
			url:  globalurl + 'addyuding',
			data: {
				yewu: wrap.yewu,
				selectDeskid: wrap.selectDeskid,
				yewuyuan: wrap.yewuyuan,
				cusinfo: wrap.cusinfo, //客户名称
				custel: wrap.custel, //客户电话
				num:wrap.num, //人数
				usetime:mui("#comeTime")[0].value,
				maxtime:mui("#expire")[0].value,
				bak:wrap.bak
			},
			type: 'POST',
			dataType: 'json',
			timeout: 15000,
			headers: {
				'UserAuthorizationSign': localStorage["UserAuthorizationSign"]
			},
			beforeSend: function() {
				mui('#warning')[0].style.display = 'block';
			},
			success: function(data) {
				
				mui('#warning')[0].style.display = 'none';
				if (data.Success) {
					mui.toast('预订单创建成功');
					mui.later(function() {
						mui.openWindow({
							url: 'yuding.html',
							id: 'yuding',
							createNew: true,
							styles: {
								cachemode: "noCache"
							}
						})
					}, 500)
				}
				else {
					mui.alert(data.Info, ' ', function() {}, 'div');
				}
			},
			complete: function(XMLHttpRequest, status) {
				mui('#warning')[0].style.display = 'none';
			}
		});
	}

})
