function searchDevices(address) {
	//注册类
	var main = plus.android.runtimeMainActivity();
	var IntentFilter = plus.android.importClass('android.content.IntentFilter');
	var BluetoothAdapter = plus.android.importClass("android.bluetooth.BluetoothAdapter");
	var BluetoothDevice = plus.android.importClass("android.bluetooth.BluetoothDevice");
	var BAdapter = BluetoothAdapter.getDefaultAdapter();
	console.log("开始搜索设备");
	var filter = new IntentFilter();
	var bdevice = new BluetoothDevice();
	var on = null;
	var un = null;
	var vlist1 = document.getElementById('list1'); //注册容器用来显示未配对设备
	vlist1.innerHTML = ''; //清空容器
	var vlist2 = document.getElementById('list2'); //注册容器用来显示未配对设备
	vlist2.innerHTML = ''; //清空容器
	var button1 = document.getElementById('bt1');
	button1.disabled = true;
	button1.innerHTML = '正在搜索...';
	BAdapter.startDiscovery(); //开启搜索
	var receiver;
	receiver = plus.android.implements('io.dcloud.android.content.BroadcastReceiver', {
		onReceive: function(context, intent) { //实现onReceiver回调函数
			plus.android.importClass(intent); //通过intent实例引入intent类，方便以后的‘.’操作
			console.log(intent.getAction()); //获取action
			if (intent.getAction() == "android.bluetooth.adapter.action.DISCOVERY_FINISHED") {
				main.unregisterReceiver(receiver); //取消监听
				button1.disabled = false;
				button1.innerHTML = '搜索设备';
				console.log(1);
				console.log("搜索结束")
			} else {
				BleDevice = intent.getParcelableExtra(BluetoothDevice.EXTRA_DEVICE);
				//判断是否配对
				if (BleDevice.getBondState() == bdevice.BOND_NONE) {
					console.log("未配对蓝牙设备：" + BleDevice.getName() + '    ' + BleDevice.getAddress());
					//参数如果跟取得的mac地址一样就配对
					if (address == BleDevice.getAddress()) {
						if (BleDevice.createBond()) { //配对命令.createBond()
							console.log("配对成功");
							var li2 = document.createElement('li'); //注册
							li2.setAttribute('id', BleDevice.getAddress()); //打印机mac地址
							li2.setAttribute('class', 'alllist');
							li2.setAttribute('data-values', BleDevice.getName());
							li2.innerText = BleDevice.getName();
							vlist2.appendChild(li2);
						}

					} else {
						if (BleDevice.getName() != on) { //判断防止重复添加
							var li1 = document.createElement('li'); //注册
							li1.setAttribute('id', BleDevice.getAddress()); //打印机mac地址
							li1.setAttribute('onclick', 'alertconnect()'); //注册click点击列表进行配对
							on = BleDevice.getName();
							li1.innerText = on;
							vlist1.appendChild(li1);

						}

					}
				} else {
					if (BleDevice.getName() != un) { //判断防止重复添加
						console.log("已配对蓝牙设备：" + BleDevice.getName() + '    ' + BleDevice.getAddress());
						var li2 = document.createElement('li'); //注册
						li2.setAttribute('id', BleDevice.getAddress()); //打印机mac地址
						li2.setAttribute('class', 'alllist');
						li2.setAttribute('data-values', BleDevice.getName());
						//li2.setAttribute('onclick', 'alertselect(id)'); //注册click点击列表进行打印
						un = BleDevice.getName();
						li2.innerText = un;
						vlist2.appendChild(li2);
						console.log(un);
					}
				}
			}

		}
	});

	filter.addAction(bdevice.ACTION_FOUND);
	filter.addAction(BAdapter.ACTION_DISCOVERY_STARTED);
	filter.addAction(BAdapter.ACTION_DISCOVERY_FINISHED);
	filter.addAction(BAdapter.ACTION_STATE_CHANGED);

	main.registerReceiver(receiver, filter); //注册监听
}

var device = null,
	BAdapter = null,
	BluetoothAdapter = null,
	uuid = null,
	main = null,
	bluetoothSocket = null;

function prints(mac_address, str) {

	if (!mac_address) {
		mui.toast('请先绑定打印机');
		return;
	}

	main = plus.android.runtimeMainActivity();
	BluetoothAdapter = plus.android.importClass("android.bluetooth.BluetoothAdapter");
	UUID = plus.android.importClass("java.util.UUID");
	uuid = UUID.fromString("00001101-0000-1000-8000-00805F9B34FB");
	BAdapter = BluetoothAdapter.getDefaultAdapter();
	device = BAdapter.getRemoteDevice(mac_address);
	plus.android.importClass(device);
	bluetoothSocket = device.createInsecureRfcommSocketToServiceRecord(uuid);
	plus.android.importClass(bluetoothSocket);

	if (!bluetoothSocket.isConnected()) {
		console.log('检测到设备未连接，尝试连接....');
		bluetoothSocket.connect();
	}

	console.log('设备已连接');

	if (bluetoothSocket.isConnected()) {
		var outputStream = bluetoothSocket.getOutputStream();
		plus.android.importClass(outputStream);
		//var string = "打印测试\r\n";
		var bytes = plus.android.invoke(str, 'getBytes', 'gbk');
		outputStream.write(0x1c);
		outputStream.write(0x21);
		outputStream.write(4); //字体纵向放大一倍

		outputStream.write(0x1c);
		outputStream.write(0x21);
		outputStream.write(8);

		outputStream.write(bytes);
		outputStream.flush();
		device = null //这里关键
		bluetoothSocket.close(); //必须关闭蓝牙连接否则意外断开的话打印错误

	}

}

function printvalue() {


	var printer = localStorage['printer'];
	console.log('b');
	if (printer != null && printer != '') {
		return JSON.parse(printer).mac;

	} else {
		return 0;
	}

}
var isComleplete = false;
	window.addEventListener("DOMContentLoaded",function(){
	isComleplete = true;	
		
	})

function pcprint(str,src) {
	//var oldstr = document.body.innerHTML;

	document.body.innerHTML = str;
	// if(isComleplete==true){
	// window.print();
	// }
	  // img1.onload = function() {
	  //          window.print();
	  //       }
	  
	  // if (typeof nw != "undefined"){
		 //  nw.Window.get.print();
	  // }
	  // else{
		  window.print();
		  //document.body.innerHTML = oldstr;
		  mui.openWindow({
		  	url:src+'?'+Math.random(),
		  	id:src
		  })
	 // }
	
}

var bds = []; // 可连接设备列表
var deviceId = null, bconnect = false;
var bss = [];	// 连接设备服务列表
var serviceId = null;
var bscs = [];	// 连接设备服务对应的特征值列表
var characteristicId = null;
var bscws = [];  // 可写特征值列表
var wcharacteristicId = null;
// 重设数据 
function resetDevices(d,s){
	d||(bds=[],deviceId=null,document.getElementById('deivce').value='');
	s||(bss=[],serviceId=null);
	// bscs=[],bscws=[],characteristicId=null,wcharacteristicId=null,document.getElementById('characteristic').value='',document.getElementById('wcharacteristic').value='';
}

// 页面初始化操作 
document.addEventListener('plusready', function(e){
	// 监听蓝牙适配器状态变化
	plus.bluetooth.onBluetoothAdapterStateChange(function(e){
		console.log('onBluetoothAdapterStateChange: '+JSON.stringify(e));
		//console.log(JSON.stringify(e));
	});
	//  监听搜索到新设备 
	plus.bluetooth.onBluetoothDeviceFound(function(e){
		console.log(1);
		var devices = e.devices;
		console.log('onBluetoothDeviceFound: '+devices.length);
		for(var i in devices){
			console.log(JSON.stringify(devices[i]));
			var device = devices[i];
			if(device.deviceId/*&&device.name&&device.name.length>0&&device.name!='null'*/){
				bds.push(device);
			}
		}
		if(!bconnect && bds.length>0){	// 默认选择最后一个
			var n = bds[bds.length-1].name;
			if(!n || n.length<=0){
				n = bds[bds.length-1].deviceId;
			}
			document.getElementById('deivce').value = n;
			deviceId = bds[bds.length-1].deviceId;
		}
	});
	//  监听低功耗蓝牙设备连接状态变化 
	plus.bluetooth.onBLEConnectionStateChange(function(e){
		console.log('onBLEConnectionStateChange: '+JSON.stringify(e));
		if(deviceId == e.deviceId){	// 更新连接状态
			bconnect = e.connected;
		}
	});
	// 监听低功耗蓝牙设备的特征值变化 
	plus.bluetooth.onBLECharacteristicValueChange(function(e){
		console.log('onBLECharacteristicValueChange: '+JSON.stringify(e));
		var value = buffer2hex(e.value);
		console.log('value(hex) = '+value);
		if(characteristicId == e.characteristicId){
			// 更新到页面显示
			document.getElementById('readvalue').value = value;
		}else if(wcharacteristicId == e.characteristicId){
			plus.nativeUI.toast(value);
		}
	});
}, false);

function buffer2hex(value){
	var t='';
	if(value){
		var v=new Uint8Array(value);
		for(var i in v){
			t += '0x'+v[i].toString(16)+' ';
		}
	}else{
		t='无效值';
	}
	return t;
}

// 打开蓝牙 
function openBluetooth(){
	outSet('打开蓝牙适配器：');
	plus.bluetooth.openBluetoothAdapter({
		success: function(e){
			mui.toast('初始化成功!');
			console.log('打开成功!');
		},
		fail: function(e){
			mui.toast('打开失败!请打开蓝牙或配对成功后再试! '+JSON.stringify(e));
		}
	});
}

// 开始搜索蓝牙设备 
function startDiscovery(){
	outSet('开始搜索蓝牙设备：');
	resetDevices();
	plus.bluetooth.startBluetoothDevicesDiscovery({
		success: function(e){
			mui.toast('开始搜索...');
			
		},
		fail: function(e){
			mui.toast('开始搜索失败! '+JSON.stringify(e));
		}
	});
}

// 停止搜索蓝牙设备 
function stopDiscovery(){
	outSet('停止搜索蓝牙设备：');
	plus.bluetooth.stopBluetoothDevicesDiscovery({
		success: function(e){
			mui.toast('停止搜索成功!');
		},
		fail: function(e){
			mui.toast('停止搜索失败! '+JSON.stringify(e));
		}
	});
}
var printersss='';
// 选择蓝牙设备 
function selectDevice(){
	if(bds.length <= 0){
		plus.nativeUI.toast('未搜索到有效蓝牙设备!');
		return;
	}
	var bts=[];
	for(var i in bds){
		var t = bds[i].name;
		if(!t || t.length<=0){
			t = bds[i].deviceId;
		}		
		bts.push({title:t});
	}
	plus.nativeUI.actionSheet({title:"选择蓝牙设备",cancel:"取消",buttons:bts}, function(e){
		if(e.index>0){
			document.getElementById('deivce').value = bds[e.index-1].name;
			deviceId = bds[e.index-1].deviceId;
			console.log('选择了"'+bds[e.index-1].name+'"');
			
			var print = {
				user: users,
				mac: deviceId,
				name: bds[e.index-1].name
			}
			localStorage['printer'] = JSON.stringify(print);
			console.log(localStorage['printer']);
			vm.getdata();
			mui('#picture').popover('hide');
			vm.id = '';
			vm.name = '';
			stopDiscovery();
		}
	});
}

// 连接蓝牙设备 
function connectDevice(){
	if(!deviceId){
		plus.nativeUI.toast('未选择设备!');
		return;
	}
	outSet('连接设备: '+deviceId);
	plus.bluetooth.createBLEConnection({
		deviceId: deviceId,
		success: function(e){
			console.log('连接成功!');
		},
		fail: function(e){
			console.log('连接失败! '+JSON.stringify(e));
		}
	});
}

// 获取设备服务 
function getServices(){
	if(!deviceId){
		plus.nativeUI.toast('未选择设备!');
		return;
	}
	if(!bconnect){
		plus.nativeUI.toast('未连接蓝牙设备!');
		return;
	}
	resetDevices(true);
	outSet('获取蓝牙设备服务:');
	plus.bluetooth.getBLEDeviceServices({
		deviceId: deviceId,
		success: function(e){
			var services = e.services;
			console.log('获取服务成功! '+services.length);
			if(services.length>0){
				for(var i in services){
					bss.push(services[i]);
					console.log(JSON.stringify(services[i]));
				}
				if(bss.length>0){	// 默认选择最后一个服务
					document.getElementById('service').value = serviceId = bss[bss.length-1].uuid;
				}
			}else{
				console.log('获取服务列表为空?');
			}
		},
		fail: function(e){
			console.log('获取服务失败! '+JSON.stringify(e));
		}
	});
}

// 选择服务 
function selectService(){
	if(bss.length <= 0){
		plus.nativeUI.toast('未获取到有效蓝牙服务!');
		return;
	}
	var bts=[];
	for(var i in bss){
		bts.push({title:bss[i].uuid});
	}
	plus.nativeUI.actionSheet({title:"选择服务",cancel:"取消",buttons:bts}, function(e){
		if(e.index>0){
			document.getElementById('service').value = serviceId = bss[e.index-1].uuid;
			console.log('选择了服务: "'+serviceId+'"');
		}
	});
}

// 获取服务的特征值 
function getCharacteristics(){
	if(!deviceId){
		plus.nativeUI.toast('未选择设备!');
		return;
	}
	if(!bconnect){
		plus.nativeUI.toast('未连接蓝牙设备!');
		return;
	}
	if(!serviceId){
		plus.nativeUI.toast('未选择服务!');
		return;
	}
	resetDevices(true, true);
	outSet('获取蓝牙设备指定服务的特征值:');
	plus.bluetooth.getBLEDeviceCharacteristics({
		deviceId: deviceId,
		serviceId: serviceId,
		success: function(e){
			var characteristics = e.characteristics;
			console.log('获取特征值成功! '+characteristics.length);
			if(characteristics.length>0){
				for(var i in characteristics){
					var characteristic = characteristics[i];
					console.log(JSON.stringify(characteristic));
					if(characteristic.properties){
						if(characteristic.properties.read){
							bscs.push(characteristics[i]);
						}
						if(characteristic.properties.write){
							bscws.push(characteristics[i]);
							if(characteristic.properties.notify||characteristic.properties.indicate){
								plus.bluetooth.notifyBLECharacteristicValueChange({	//监听数据变化
									deviceId: deviceId,
									serviceId: serviceId,
									characteristicId: characteristic.uuid,
									success: function(e){
										console.log('notifyBLECharacteristicValueChange '+characteristic.uuid+' success.');
									},
									fail: function(e){
										console.log('notifyBLECharacteristicValueChange '+characteristic.uuid+' failed! '+JSON.stringify(e));
									}
								});
							}
						}
					}
				}
				if(bscs.length>0){	// 默认选择最后特征值
					document.getElementById('characteristic').value = characteristicId = bscs[bscs.length-1].uuid;
				}
				if(bscws.length>0){	// 默认选择最后一个可写特征值
					document.getElementById('wcharacteristic').value = wcharacteristicId = bscws[bscws.length-1].uuid;
				}
			}else{
				console.log('获取特征值列表为空?');
			}
		},
		fail: function(e){
			console.log('获取特征值失败! '+JSON.stringify(e));
		}
	});
}

// 选择特征值(读取) 
function selectCharacteristic(){
	if(bscs.length <= 0){
		plus.nativeUI.toast('未获取到有效可读特征值!');
		return;
	}
	var bts=[];
	for(var i in bscs){
		bts.push({title:bscs[i].uuid});
	}
	plus.nativeUI.actionSheet({title:'选择特征值',cancel:'取消',buttons:bts}, function(e){
		if(e.index>0){
			document.getElementById('characteristic').value = characteristicId = bscs[e.index-1].uuid;
			console.log('选择了特征值: "'+characteristicId+'"');
		}
	});
}

// 读取特征值数据 
function readValue(){
	if(!deviceId){
		plus.nativeUI.toast('未选择设备!');
		return;
	}
	if(!bconnect){
		plus.nativeUI.toast('未连接蓝牙设备!');
		return;
	}
	if(!serviceId){
		plus.nativeUI.toast('未选择服务!');
		return;
	}
	if(!characteristicId){
		plus.nativeUI.toast('未选择读取的特征值!');
		return;
	}
	outSet('读取蓝牙设备的特征值数据: ');
	plus.bluetooth.readBLECharacteristicValue({
		deviceId: deviceId,
		serviceId: serviceId,
		characteristicId: characteristicId,
		success: function(e){
			console.log('读取数据成功!');
		},
		fail: function(e){
			console.log('读取数据失败! '+JSON.stringify(e));
		}
	});
}

// 选择特征值(写入) 
function selectwCharacteristic(){
	if(bscws.length <= 0){
		plus.nativeUI.toast('未获取到有效可写特征值!');
		return;
	}
	var bts=[];
	for(var i in bscws){
		bts.push({title:bscws[i].uuid});
	}
	plus.nativeUI.actionSheet({title:'选择特征值',cancel:'取消',buttons:bts}, function(e){
		if(e.index>0){
			document.getElementById('wcharacteristic').value = wcharacteristicId = bscws[e.index-1].uuid;
			console.log('选择了特征值: "'+wcharacteristicId+'"');
		}
	});
}

// 写入特征值数据 
function writeValue(){
	if(!deviceId){
		plus.nativeUI.toast('未选择设备!');
		return;
	}
	if(!bconnect){
		plus.nativeUI.toast('未连接蓝牙设备!');
		return;
	}
	if(!serviceId){
		plus.nativeUI.toast('未选择服务!');
		return;
	}
	if(!wcharacteristicId){
		plus.nativeUI.toast('未选择写入的特征值!');
		return;
	}
	var value = document.getElementById('writevalue').value;
	if(!value || value==''){
		plus.nativeUI.toast('请输入需要写入的数据');
		document.getElementById('writevalue').focus();
		return;
	}
	// 转换为ArrayBuffer写入蓝牙
	str2ArrayBuffer(value, function(buffer){
		outSet('写入蓝牙设备的特征值数据: ');
		plus.bluetooth.writeBLECharacteristicValue({
			deviceId: deviceId,
			serviceId: serviceId,
			characteristicId: wcharacteristicId,
			value: buffer,
			success: function(e){
				console.log('写入数据成功!');
			},
			fail: function(e){
				console.log('写入数据失败! '+JSON.stringify(e));
			}
		});
	});
}

function str2ArrayBuffer(s,f) {
    var b = new Blob([s],{type:'text/plain'});
    var r = new FileReader();
    r.readAsArrayBuffer(b);
    r.onload = function(){if(f)f.call(null,r.result)}
}


// 断开蓝牙设备
function disconnectDevice(){
	if(!deviceId){
		plus.nativeUI.toast('未选择设备!');
		return;
	}
	resetDevices(true);
	outSet('断开蓝牙设备连接：');
	plus.bluetooth.closeBLEConnection({
		deviceId: deviceId,
		success: function(e){
			console.log('断开连接成功!');
		},
		fail: function(e){
			console.log('断开连接失败! '+JSON.stringify(e));
		}
	});
}

// 关闭蓝牙
function closeBluetooth(){
	outSet('关闭蓝牙适配器：');
	resetDevices();
	plus.bluetooth.closeBluetoothAdapter({
		success: function(e){
			console.log('关闭成功!');
			bconnect = false;
		},
		fail: function(e){
			console.log('关闭失败! '+JSON.stringify(e));
		}
	});
}

var	_dout_=document.getElementById("output");

// 输出内容
function outSet(s){
	console.log(s);
	_dout_.innerText=s+"\n";
	(0==_dout_.scrollTop)&&(_dout_.scrollTop=1);//在iOS8存在不滚动的现象
};
// 输出行内容
function outLine(s){
	console.log(s);
	_dout_.innerText+=s+"\n";
	(0==_dout_.scrollTop)&&(_dout_.scrollTop=1);//在iOS8存在不滚动的现象
};