mui.init();

var vm = new Vue({
	el: '.mui-content',
	data: {
		store_no: '',
		ImgPath: [],
		user: '1',
		allnumber: '6',
		outnumber: '6',
		imgup: '',
		imgPathstring: '',
		ComName: '', //店铺名称
		contactName: '', //联系人
		email: '', //邮箱
		address: '', //公司地址
		introduce: '', //公司简介
		province: '',
		city: '',
		tel:''
	},
	methods: {
		datalod:function(){
			
			 if (this.user != 0) {
			    var _this = this;
			    mui.ajax({
			        url:  globalurl + 'h5getstore',
			        data: {
			            user: this.user
			        },
								
			        type: 'POST',
			        dataType: 'json',
			        timeout: 15000,
			        success: function (data) {
			             
			            if (data.Success) {
							 
							var shop=data.Data[0];
							//console.log(shop);
			               _this.ComName=shop.name;
						    _this.contactName=shop.usname;
							 _this.tel=shop.tel;
							  _this.email=shop.email;
							   _this.address=shop.addr;
							    _this.province=shop.city1;
								 _this.city=shop.city2;
								  _this.introduce=shop.introduce;
								  if(shop.img!='https://hangbanpiao-request.rooxi.net:4439'){
									  mui("#portrait")[0].setAttribute('src', shop.img);
								  }
								if (_this.province!=null) {
									mui('.selectAdd')[0].value = _this.province + _this.city;
								}
								
					
			
			               //console.log(_this.shop);
			               
			            } else {
			                mui.toast(data.Info);
								
			            }
			        },
			        error: function (xhr, type, errorThrown) {
			            mui.toast(type);
			        }
								
			    });
			}
		},
		addpro: function() {
			var that = this;
			 
			if(this.ComName == ''||this.ComName == null) {
				mui.alert('请输入店铺名称', ' ', function() {}, 'div');
				return;
			} else if(this.contactName == ''||this.contactName ==null) {
				mui.alert('请输入联系人', ' ', function() {}, 'div');
				return;
			} else if(this.province == '' || this.city == '') {
				mui.alert('请选择店铺地址', ' ', function() {}, 'div');
				return;
			} else if(this.address == ''||this.address == null) {
				mui.alert('请输入详细地址', ' ', function() {}, 'div');
				return;
			} 
			
			else if(this.tel == ''||this.tel==null) {
				
				mui.alert('请输入服务电话', ' ', function() {}, 'div');
				return;
			} else {
				this.imgPathstring = this.ImgPath.toString();
				var that = this;
				
				mui.ajax(globalurl + 'alterstore', {
					data: {
						urname: that.contactName,
						spname: that.ComName,
						address: that.address,
						city1: that.province,
						city2: that.city,
						email: that.email,
						intro: that.introduce,
						tel:that.tel,
						user:that.user
					},
					dataType: 'json',
					type: 'POST',
					timeout: 10000, //超时时间设置为10秒；
					
					beforeSend: function() {
						mui('#warning')[0].style.display = 'block';
					},
					success: function(data) {
						
						if(data.Success) {
							 
							mui.toast('操作成功');
							if(localStorage["UserAuthorizationSign"] != null) {
								mui.later(function() {
									mui.openWindow({
										url: 'main.html',
										id: 'main.html',
										createNew: true,
										styles: {
											cachemode: "noCache"
										}
									})
								}, 600)
							} else if(localStorage["UserAuthorizationSign"] == null) {
								mui.later(function() {
									mui.openWindow({
										url: 'login.html',
										id: 'login',
										createNew: true,
										styles: {
											cachemode: "noCache"
										}
									})
								}, 600)
							}

						} else {
							mui.toast(data.Info);
						}

					},
					complete: function(XMLHttpRequest, status) {
						mui('#warning')[0].style.display = 'none';
						if(status == 'timeout') {
							mui.toast('网络超时');
						}
					}
				});
			}
		},
		upload: function(value) {
			var _this = this;
			console.log(value);
			mui.ajax(dcurl+'store/storeinfo_api.aspx', {
				data: {
					cmd: '31',
					base64: value
				},
				dataType: 'json',
				type: 'POST',
				timeout: 10000, //超时时间设置为10秒；
				headers: {
					'UserAuthorizationSign': localStorage["UserAuthorizationSign"]
				},
				success: function(data) {
					if(data.code == '0000') {
						mui.toast('图片上传成功');
					} else {
						mui.toast('图片上传失败');
					}
				},
				complete: function(XMLHttpRequest, status) {
					if(status == 'timeout') {
						that.upload(value);
					}
				}
			});
		},
		arrtoString: function() {
			this.imgPathstring.toString();
		}
	},
	beforeMount:function(){
		
	},
	mounted:function(){
		
		
	},
	filters: {
		capitalize: function(value) {
			if(value == '') return '../ajax/image/upload/4.jpg';
			return '/ajax/image/upload/' + value;
		}
		
	}
});
document.getElementById('upimg').addEventListener('tap', function() {
	document.getElementById('fileclick').click();
});
document.getElementById('subpro').addEventListener('tap', function() {
	vm.addpro();
});

function imgDel(obj) {
	 
	mui.confirm('要删除此图片吗', ' ', function(e) {
		if(e.index == 1) {
			var img = $(obj)[0].src;
			$.ajax({
				url: "../ajax/UpImage.ashx?cmd=delimg",
				data: {
					"imgsrc": img
				},
				type: "post",
				async: false,
				success: function(data) {

					if(data != "false") {
						var imgp = img.split('/');
						var imgppp = imgp[imgp.length - 1];
						var index = vm.ImgPath.indexOf(imgppp);
						if(index > -1) {
							vm.ImgPath.splice(index, 1);
						}

						vm.outnumber++;

					} else {
						mui.toast("删除失败。");
					}
				}
			})
		}

	}, 'div')
}

mui('#feedback').on('tap', '.selectAdd', function() {
	var picker = new mui.PopPicker({
		layer: 2
	});
	picker.setData(init_city_picker);
	picker.show(function(selectItems) {
		vm.province = selectItems[0].text;
		vm.city = selectItems[1].text;
		mui('.selectAdd')[0].value = selectItems[0].text + selectItems[1].text;
		picker.dispose();
	})
})

mui('#feedback').on('change', '#fileclick', function() {
	var obj = this.files[0];
	var fr = new FileReader();
	fr.onload = function() {
		var value = this.result;
		mui("#portrait")[0].setAttribute('src', value);
		mui('#baseImg')[0].value = value;
		mui.later(function() {
			vm.upload(value);
		}, 100)
	};
	fr.readAsDataURL(obj);

})

mui('#feedback').on('tap', '.iconSpan', function() {
	mui.openWindow({
		url: 'map.html',
		id: 'map',
		createNew: true,
		styles: {
			cachemode: "noCache"
		}
	})
})
window.onload=function(){
	pageload();
	vm.datalod();
}